import { CommandHandler } from '@nestjs/cqrs';
import { RedisConfigurationRepository } from '../../adapters/secondaries/redis-configuration.repository';
import { DeleteConfigurationCommand } from '../../commands/delete-configuration.command';

@CommandHandler(DeleteConfigurationCommand)
export class DeleteConfigurationUseCase {
  constructor(private _configurationRepository: RedisConfigurationRepository) {}

  async execute(deleteConfigurationCommand: DeleteConfigurationCommand) {
    await this._configurationRepository.del(
      deleteConfigurationCommand.deleteConfigurationRequest.domain +
        ':' +
        deleteConfigurationCommand.deleteConfigurationRequest.key,
    );
  }
}
