import { Injectable } from '@nestjs/common';
import { ICreateGeorouter } from '../../domain/interfaces/georouter-creator.interface';
import { IGeorouter } from '../../domain/interfaces/georouter.interface';
import { GraphhopperGeorouter } from './graphhopper-georouter';
import { HttpService } from '@nestjs/axios';

@Injectable()
export class GeorouterCreator implements ICreateGeorouter {
  constructor(private readonly httpService: HttpService) {}

  create(type: string, url: string): IGeorouter {
    switch (type) {
      case 'graphhopper':
        return new GraphhopperGeorouter(url, this.httpService);
      default:
        throw new Error('Unknown geocoder');
    }
  }
}
